#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include "string.h"
#include "senddata.h"

extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС

uint8  buffer[16384];
int main(void)
{
	uint8 server_ip[4]={192,168,1,101};			// Զ̷IPַ
	uint16 server_port=3000;								// Զ̷˿
  uint16 local_port=5000;									// ʼһض˿
  uint16 len=0;
	
  /***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	/***** жϿ *****/
	NVIC_Configuration();
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	DMA_Configuration();
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
//  at24c16_init();	
	/***** ӲW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket
	
	/***** W5500Keepalive *****/
	setkeepalive(0);													//
	
	printf("TCP Server IP: %d.%d.%d.%d \r\n",server_ip[0],server_ip[1],server_ip[2],server_ip[3]);
  printf("TCP Server Port: %d \r\n",server_port);	
	printf("W5500 Init Complete!\r\n");
  printf("Start TCP Client Test!\r\n"); 
  
	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																				// Socket״̬
	{	
		switch(getSn_SR(0))														// ȡsocket0״̬
		{
			case SOCK_INIT:															// Socketڳʼ()״̬
					connect(0, server_ip,server_port);			// Sn_CRΪCONNECTTCP		
			break;
			case SOCK_ESTABLISHED:											// Socketӽ״̬
					if(getSn_IR(0) & Sn_IR_CON)   					
					{
						setSn_IR(0, Sn_IR_CON);								// Sn_IRCONλ1֪ͨW5500ѽ
					}
					// ݻػԳݴλW5500W5500յݺٻظ
					len=getSn_RX_RSR(0);										// len=Socket0ջѽպͱݴС
					
					if(len>=sizeof(buffer))
					{
					  recv(0,(uint8*)buffer,len);										// W5500ԷݣͨSPI͸MCU
//						printf("%d\r\n",len);							    // ڴӡյ
						send(0,(uint8*)buffer,len);										// յݺٻظݻػ						
					}
					else if (len)
					{
							len=recv(0,(uint8*)buffer,len);		
       				
//						  printf("0:%d\r\n",len);		
						  send(0,buffer,len);										// յݺٻظݻػ
					}						
					
			break;
			case SOCK_CLOSE_WAIT:												// Socketڵȴر״̬
			disconnect(0);	
			break;
			case SOCK_CLOSED:														// Socketڹر״̬
					socket(0,Sn_MR_TCP,local_port,Sn_MR_ND);		// Socket0ΪTCPʱģʽһض˿
			break;
		}
	}
}


